/************************************************************************
 *
 * Author : Jean-Francois Huppert & Pascal Vincent
 *          LPNHE-Paris
 * e-mail : huppert@lpnhep.in2p3.fr, vincentp@in2p3.fr 
 * Date   : 5 june 2001
 * Modi : j-Luc panazol oct 2007
 *
 ************************************************************************
 * FanPapatPilot.h
 */

#define SHOW_MENU              0x100
#define RWBUF_SIZE             1024
#define FIFO_BLOCK_FILE_SZ     48
#define BLK_MAX_DATA           128
#define SCRIPTS_MAX            64
#define SCRIPTS_RECURSIVITY    4
#define SCRIPT_NAME_LENGTH     128
//#define FIFO_BLOCK_FILE_NAME   "/home/hess/Sdaq/Driver/fanPapat/FanPilot/FanPapat_Block_file"
//#define FIFO_SCRIPT_DIR        "/home/hess/Sdaq/Driver/fanPapat/FanPilot/FifoScripts"
//#define FIFO_SCRIPT_LIST       "/home/hess/Sdaq/Driver/fanPapat/FanPilot/FifoScripts/FifoScripts_List"
#define FIFO_BLOCK_FILE_NAME   "/home3/panazol/lpnhe/Sdaq/Driver/fanPapat/FanPilot/FanPapat_Block_file"
#define FIFO_SCRIPT_DIR        "/home3/panazol/lpnhe/Sdaq/Driver/fanPapat/FanPilot/FifoScripts"
#define FIFO_SCRIPT_LIST       "/home3/panazol/lpnhe/Sdaq/Driver/fanPapat/FanPilot/FifoScripts/FifoScripts_List"

/************************************************************************
 * Global variables
 */

#ifdef __MAIN__
#define SEXTERN
#else
#define SEXTERN extern
#endif

/*
 *  ==================================================================
 *  DEBUGGING ....
 *  ==================================================================
 *  diag levels we can add or remove... most we let stay
 *  and be activated under DEBUG  - FATALS use printk !!!
 */
// #define FAN_DEBUG             /* activate debugging routines  */
#undef FAN_DEBUG
 
#ifdef  FAN_DEBUG
#define FAN_TRACE(x)  printf x      // Debugging primitives
#else
#define FAN_TRACE(x)
#endif
                
SEXTERN int
    last_deleted,
    last_ideleted,
    val,
    file_desc;

SEXTERN unsigned int
    fifo_pattern;

SEXTERN unsigned int
param,param2;

SEXTERN unsigned long long int
    lastp64,
  param64,param2_64;
  
SEXTERN char
    com[128],
    prm[128];

SEXTERN unsigned int custbuf[RWBUF_SIZE];

typedef struct {
    unsigned short id;
    unsigned short lg;
    char cmt[64];
    unsigned long long int data[BLK_MAX_DATA];
  } F_Block;

SEXTERN F_Block Block_file[FIFO_BLOCK_FILE_SZ];
SEXTERN int order[FIFO_BLOCK_FILE_SZ];

SEXTERN int  Blk_File;
SEXTERN int  Script_File;
SEXTERN int  Scripts_List;

SEXTERN char Blk_File_name[64];
SEXTERN char Current_Script_name[SCRIPT_NAME_LENGTH];
SEXTERN char Script_name[SCRIPTS_MAX][SCRIPT_NAME_LENGTH];
SEXTERN char Script_Used_name[SCRIPTS_RECURSIVITY][SCRIPT_NAME_LENGTH];
SEXTERN char scrbuf[4*SCRIPTS_MAX*SCRIPT_NAME_LENGTH];
SEXTERN char scrcmt[SCRIPTS_MAX][64];


/************************************************************************
 * Function prototype
 */

extern void Tridiot(void);
extern int  Get_Fifo_BLks(char *);
extern int  List_Fifo_BLks(int);
extern int  Define_Fifo_BLk(int);
extern int  Delete_Fifo_BLk(int);
extern int  Read_Scripts_List(int *); 

extern int cPCI_FAN_IOgrp_Read(int, unsigned int);
extern int cPCI_FAN_IOgrp_Write(int, unsigned int, int);
extern int cPCI_FAN_Mode_IO(int, unsigned int);
extern int cPCI_FAN_Read_RegDac(int, unsigned int);
extern int cPCI_FAN_Write_RegDac(int, int, unsigned int);
extern int cPCI_FAN_WrTran_RegDac(int, int, unsigned int);
extern int cPCI_FAN_Read_Temp(int, int);
extern int cPCI_FAN_Tran_All(int);

extern unsigned int FAN_Read(int, unsigned int *);
extern int FAN_Write(int, unsigned int, unsigned int);

extern int cPCI_Temp_Ctrl_Read(int);
extern int cPCI_Temp_Ctrl_Write(int, unsigned int);
extern int cPCI_Temp_Status1_Read(int);
extern int cPCI_Temp_Status2_Read(int);
extern int cPCI_Temp_MUX_Read(int);
extern int cPCI_Temp_MUX_Write(int, unsigned int);
extern int cPCI_Temp_MUX_VALUE_Read(int,float*);
extern int cPCI_Fan_Ctrl_Read(int);
extern int cPCI_Fan_Ctrl_Write(int, unsigned int);
extern int cPCI_Fan_Status_Read(int,int*);
extern int cPCI_Led_Ctrl_Read(int);
extern int cPCI_Led_Ctrl_Write(int, unsigned int);
extern int cPCI_Led_Status_Read(int);
extern int cPCI_GPIO_Status_Read(int,int*);
extern int cPCI_GPIO_Report_Read(int,int*);
extern int cPCI_GPIO_Update_Read(int,int*);
extern int cPCI_GPIO_Update_Write(int, unsigned int);
extern int cPCI_GPIO_Ctrl_Write(int, unsigned int);
extern int cPCI_GPIO_Password_Write(int, unsigned int);
extern int cPCI_Photodiode_Ctrl_Read(int);
extern int cPCI_Photodiode_Ctrl_Write(int, unsigned int);
extern int cPCI_Photodiode_Status1_Read(int);
extern int cPCI_Photodiode_Status2_Read(int);
extern int cPCI_Config_CFR_Write(int, unsigned int);
extern int cPCI_CFR_Read(int);
extern int cPCI_CFR_Write(int, unsigned int);
extern int cPCI_Photodiode_Value_Read(int,int*);
extern int cPCI_TestRegister_Read(int);
extern int cPCI_Test_Register_Write(int, unsigned int);
extern int cPCI_FPGA_Version_Read(int);
extern int cPCI_General_Ctrl_Read(int);
extern int cPCI_General_Ctrl_Write(int, unsigned int);
extern int cPCI_General_Status_Read(int);
extern int cPCI_Interrupt_Test_Read(int);
extern int cPCI_Interrupt_Test_Write(int, unsigned int);
extern int cPCI_Zone_Fan_DAC_Register_Write(int, unsigned int,unsigned int);
extern int cPCI_Calib_Led_Register_Read(int, unsigned int);
extern int cPCI_Calib_Led_Register_Write(int, unsigned int,unsigned int);
extern int cPCI_Zone_Fan_DAC_Register_Read(int, unsigned int);
extern int cPCI_Last_Temperature_Value_Read(int, unsigned int);

