/************************************************************************
 *
 * this process makes the different cPCI slowcontrol interface (fans and temperatures)
 * ioctl's available from the shell level
 *  
 * Author : Jean-Francois Huppert & Pascal Vincent
 *          LPNHE-Paris
 * Modification : Panazol jean-luc
 * e-mail : huppert@lpnhep.in2p3.fr, vincentp@in2p3.fr 
 * Date   : 5 june 2001
 * Modif  : J-Luc PANAZOL oct 2007
 ************************************************************************
 * CtrlSecurityPilot.c
 */

#include <sys/types.h> 
#include <sys/stat.h>
#include <fcntl.h> 
#include <unistd.h>
#include <sys/ioctl.h>   
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <errno.h>
#include <ctype.h>
#include <time.h>
#include <termios.h>

#include "HESSDAQDefine.h"
#include "HESSDAQControl.h"
#include "cpu_def.h"    
#include "ctrlsecurity_def.h"     

#define __MAIN__
#include "CtrlSecurityPilot.h"
#undef __MAIN__


/************************************************************************/

int main(int argc, char *argv[]) {

  int 
    i,
    j,
    gbf,
    display,
    nval = 0,
    nsscan,
    ret_val,
    scripts,
    nscripts,
    scr_level,
    block_num,
    count = 0;

  time_t
    t1,
    t2;

  char 
    mess[256],
    *pt;

  FILE * ScF;
  int indesc[SCRIPTS_RECURSIVITY];

  struct termios
    confg_term,
    sauve_term;

  static int
    last_val;

//--------------------------------------------------------------------

  setbuf(stdin, NULL);
  printf("\n\n");

  if ((file_desc = open(FAN_DEVICE_NAME, O_RDWR)) < 0) {
    printf ("Error %d Can't open device file: %s\n",file_desc,FAN_DEVICE_NAME);
    exit(1);
  }

  // init 0x7f2  
  while(ch=getch()) {
    cPCI_Temp_Ctrl_Write(file_desc,0x7f2);
    for(int cpt=0; cpt<32; cpt++) {
      cPCI_Temp_MUX_Write(file_desc, cpt);
      qui = cPCI_Temp_MUX_Read(file_desc);
      valeur = cPCI_Temp_MUX_VALUE_Read(file_desc);
      printf("%2.3f\t",valeur);
    }
    printf("\n");
    wait(1000);
  }

  close(file_desc);
  exit(0);
}
